%global gittagversion 1.5.0
%global gittag v%{?gittagversion}

Name:           pinnwand
Version:        %{?gittagversion}
Release:        1%{?dist}
Summary:        Straightforward pastebin software

License:        MIT
URL:            https://github.com/supakeen/pinnwand

Source:         %{url}/archive/%{gittag}/%{name}-%{version}.tar.gz
Source:         pinnwand.service 

# Upstream switched to `pdm` from poetry for 1.5.0, but this prevents creation
# of the pinnwand entrypoint during build
Patch:          https://github.com/supakeen/pinnwand/pull/211.patch

BuildArch:      noarch
BuildRequires:  python3-devel
BuildRequires:  python3-pytest
BuildRequires:  systemd-rpm-macros

%global _description %{expand:
pinnwand is Python pastebin software that tried to keep it simple but got a
little more complex
}

%description %_description

%prep
%autosetup -p 1 -n pinnwand-%{version}

# NOTE(neil): 2023-10-26 pinnwand 1.5.0 wants sqlalchemy >= 2, but Fedora has
# not upgraded to # it yet. See:
# https://src.fedoraproject.org/rpms/python-sqlalchemy/pull-request/16
sed -i 's/sqlalchemy>=2/sqlalchemy<2/' pyproject.toml

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files pinnwand

install -Dpm 0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
install -Dpm 0644 etc/pinnwand.toml-example %{buildroot}%{_sysconfdir}/%{name}/%{name}.toml

%check
%pytest

%post 
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files -f %{pyproject_files}
%dir %{_sysconfdir}/%{name}
%doc README.md
%license LICENSE AUTHORS.rst
%{_bindir}/%{name}
%{_unitdir}/pinnwand.service
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.toml

%changelog
* Mon Jan 08 2024 Neil Hanlon <neil@shrug.pw> - 1.5.0-1
- Update to 1.5.0

* Thu Aug 03 2023 Neil Hanlon <neil@shrug.pw> - 1.4.0-1
- Update to 1.4.0

* Sun Feb 20 2022 supakeen <cmdr@supakeen.com> - 1.3.2-1
- Initial version of the package.
